<?php

ini_set("auto_detect_line_endings", true); //make sure CSV files created on Mac are properly read

if ( $_GET['action'] === 'parseCSVfile' && ( isset($_GET['fileURL']) && isset($_GET['urlType']) ) ) {
	getCSVFile( $_GET['fileURL'], $_GET['urlType']);
}

function getCSVFile( $fileURL, $urlType )
{
	if ( $urlType === 'rwResource' || $urlType === 'relativeURL' ) {
		//The PHP file is buried one level deeper than the URL passed in, so need to adjust file path accordingly
		$csvFile = fopen( dirname(__FILE__) . '/../' . $fileURL, 'r' );
	} else if ( $urlType === 'absoluteURL' ) {
		//Retrieve remote CSV file
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_URL, $fileURL);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 5);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false); //allow secure connections to be used when retrieving CSV file
		$csvFileData = curl_exec($curl);
		curl_close($curl);
		//Create random temp CSV file locally, so we can use fopen and pass resource to fgetcsv
		$randomFile = mt_rand();
		$csvFile = fopen('temp' . $randomFile . '.csv', 'w');
		fwrite($csvFile, $csvFileData);
		fclose($csvFile);
		$csvFile = fopen('temp' . $randomFile . '.csv', 'r');
	}
	
	if ( $csvFile !== FALSE ) {
		$row = 1;
		$ticks = array();
		$labels = array();
		$series1 = array();
		$series2 = array();
		$series3 = array();
		$series4 = array();
		$series5 = array();
		$series6 = array();
		$series7 = array();
		$series8 = array();
		$series9 = array(); 
		$series10 = array();
		$series11 = array();
		$series12 = array();
		$series13 = array();
		$series14 = array();
		$series15 = array();
		$series16 = array();
		$series17 = array();
		$series18 = array();
		$series19 = array(); 
		$series20 = array();
		$numOfSeries = 1;
		while ( ( $data = fgetcsv($csvFile, '', ",") ) !== FALSE ) {
	        
	        $num = count($data);
	        for ($col=0; $col < $num; $col++) {
	            if ( $row === 1 ) {
		        	$numOfSeries = count($data) - 1;
		        	if ($col !== 0) { $labels[] = $data[$col]; } //Don't need the first column label, as that's the label for the x-axis, which is user-specified in stack settings
			    }
	            switch($col) {
		            case 0:
		            	if ( $row !== 1 ) { $ticks[] = $data[$col]; }
		            	break;
		            case 1:
		            	if ( $row !== 1 ) { $series1[] = $data[$col]; }
		            	break;
		            case 2:
		            	if ( $row !== 1 ) { $series2[] = $data[$col]; }
		            	break;
		            case 3:
		            	if ( $row !== 1 ) { $series3[] = $data[$col]; }
		            	break;
		            case 4:
		            	if ( $row !== 1 ) { $series4[] = $data[$col]; }
		            	break;
		            case 5:
		            	if ( $row !== 1 ) { $series5[] = $data[$col]; }
		            	break;
		            case 6:
		            	if ( $row !== 1 ) { $series6[] = $data[$col]; }
		            	break;
		            case 7:
		            	if ( $row !== 1 ) { $series7[] = $data[$col]; }
		            	break;
		            case 8:
		            	if ( $row !== 1 ) { $series8[] = $data[$col]; }
		            	break;
		            case 9:
		            	if ( $row !== 1 ) { $series9[] = $data[$col]; }
		            	break;
		            case 10:
		            	if ( $row !== 1 ) { $series10[] = $data[$col]; }
		            	break;
		            case 11:
		            	if ( $row !== 1 ) { $series11[] = $data[$col]; }
		            	break;
		            case 12:
		            	if ( $row !== 1 ) { $series12[] = $data[$col]; }
		            	break;
		            case 13:
		            	if ( $row !== 1 ) { $series13[] = $data[$col]; }
		            	break;
		            case 14:
		            	if ( $row !== 1 ) { $series14[] = $data[$col]; }
		            	break;
		            case 15:
		            	if ( $row !== 1 ) { $series15[] = $data[$col]; }
		            	break;
		            case 16:
		            	if ( $row !== 1 ) { $series16[] = $data[$col]; }
		            	break;
		            case 17:
		            	if ( $row !== 1 ) { $series17[] = $data[$col]; }
		            	break;
		            case 18:
		            	if ( $row !== 1 ) { $series18[] = $data[$col]; }
		            	break;
		            case 19:
		            	if ( $row !== 1 ) { $series19[] = $data[$col]; }
		            	break;
		            case 20:
		            	if ( $row !== 1 ) { $series20[] = $data[$col]; }
		            	break;
	            }
	        }
	        $row++;
	    }
	    $series1 = preg_replace('/"/','',json_encode($series1));
	    $series2 = preg_replace('/"/','',json_encode($series2));
	    $series3 = preg_replace('/"/','',json_encode($series3));
	    $series4 = preg_replace('/"/','',json_encode($series4));
	    $series5 = preg_replace('/"/','',json_encode($series5));
	    $series6 = preg_replace('/"/','',json_encode($series6));
	    $series7 = preg_replace('/"/','',json_encode($series7));
	    $series8 = preg_replace('/"/','',json_encode($series8));
	    $series9 = preg_replace('/"/','',json_encode($series9));
	    $series10 = preg_replace('/"/','',json_encode($series10));
	    $series11 = preg_replace('/"/','',json_encode($series11));
	    $series12 = preg_replace('/"/','',json_encode($series12));
	    $series13 = preg_replace('/"/','',json_encode($series13));
	    $series14 = preg_replace('/"/','',json_encode($series14));
	    $series15 = preg_replace('/"/','',json_encode($series15));
	    $series16 = preg_replace('/"/','',json_encode($series16));
	    $series17 = preg_replace('/"/','',json_encode($series17));
	    $series18 = preg_replace('/"/','',json_encode($series18));
	    $series19 = preg_replace('/"/','',json_encode($series19));
	    $series20 = preg_replace('/"/','',json_encode($series20));
	    $csvData = "[$numOfSeries,".json_encode($ticks).",".json_encode($labels).",".$series1.",".$series2.",".$series3.",".$series4.",".$series5.",".$series6.",".$series7.",".$series8.",".$series9.",".$series10.",".$series11.",".$series12.",".$series13.",".$series14.",".$series15.",".$series16.",".$series17.",".$series18.",".$series19.",".$series20."]";
	    echo $csvData;
	    fclose($csvFile);
	    if(file_exists('temp' . $randomFile . '.csv')) { unlink('temp' . $randomFile . '.csv'); }
	} else {
		if ( isset($errno) || isset($errstr) ) {
			echo( $errstr . ' (' . $errno . ')' . PHP_EOL );
		} else {
			echo('File could not be opened. This could mean the file does not exists, that the path to the file is incorrect, or that the file is corrupt.');
		}
	}
}

?>